proc Balloon { w msg } {
  bind $w <Enter>  +[list Balloon:Enter %W %X %Y $msg]
  bind $w <Leave>  +[list Balloon:Destroy %W]
}

proc Balloon:Enter { w X Y msg } {
  global Balloon
  set win $w.balloon
  set Balloon($win,id) [after 500 Balloon:Pack $w $win $X $Y [list $msg]]
}

proc Balloon:Pack { wt w X Y msg } {
  global Balloon
  catch [destroy $w]
  if [winfo exists $wt] {
    toplevel $w -bg blue2 -height 0 -width 0 -padx 0 -pady 0
    wm withdraw $w
    wm overrideredirect $w 1
    pack [label $w.l -text $msg -bg yellow2 -padx 3 -pady 0] -fill both -padx 0 -pady 0
    set ms [wm maxsize .]
    set mX [lindex $ms 0]
    set mY [lindex $ms 1]
    update idletasks
    set fX [winfo reqwidth $w.l]
    if { [expr $fX + $X] >= $mX } { set X [expr $mX - 7 - $fX] }
    wm geometry $w +[expr $X + 5]+[expr $Y + 5]
    wm deiconify $w
    unset -nocomplain Balloon($w,id)
  }
}

proc Balloon:Destroy { w } {
  global Balloon
  set w $w.balloon
  if [winfo exists $w] {
    destroy $w
  } else {
    after cancel $Balloon($w,id)
  }
}