#
# DMegaWdg -   
# ver 0.1.2
# : Eduard E. Zozulya (C) 2002 e-mail: doro@doro.poltava.ua
#
# http://doro.poltava.ua
#

namespace eval DMegaWdg {

#   wdgname   body
proc Create { wdgname args } {
  variable DMegaWdg

  if { [llength $args] != 3 } {
    error "USAGE: DMegaWdg::Create body names opts"
  }
  if { [info exists DMegaWdg($wdgname,body)] } {
    error "Widget $wdgname already exists !!!"
  }

  set DMegaWdg($wdgname,body)   [lindex $args 0]
  set DMegaWdg($wdgname,names)  [lindex $args 1]
  set DMegaWdg($wdgname,opts)   [lindex $args 2]
  lappend DMegaWdg(allmegawdg) $wdgname
  
  proc $wdgname { args } {
    variable DMegaWdg

    set frame     [lindex $args 0]
    set procname  [lindex [info level 0] 0]

    frame $frame -takefocus 0 -padx 0 -pady 0 -highlightthickness 0 -bd 0

    set DMegaWdg($frame,wdgname) $procname
    
    #     
    regsub -all "\\.\\." $DMegaWdg($procname,body) "~~~~" nbody
    regsub -all "\\.\[A-z\\.]+" $nbody "$frame&" nbody
    regsub -all "~~~~" $nbody "." nbody
    eval $nbody
    
    #   
    set defwdg  [LSearchNP $DMegaWdg($procname,opts) "*" +1]
    set allopts [lrange $args 1 end]
    foreach { megaopt wdg opt } $DMegaWdg($procname,opts) {
      if { $opt != "" } {
        set varopt [LSearchNP $allopts $megaopt +1]
        if { "$varopt" != "" } { $frame$wdg configure $opt $varopt }
      }
    }

    #    ( * _ )
    foreach { opt varopt } $allopts {
      if { [lsearch $DMegaWdg($procname,opts) $opt] == -1 } {
        $frame$defwdg configure $opt $varopt
      }
    }
    
    #    wdgname
    proc DMegaWdg:FocusIn { frame } {
      variable DMegaWdg
      if { [focus -lastfor $frame] == "$frame" } {
        focus -force $frame[LSearchNP $DMegaWdg($DMegaWdg($frame,wdgname),opts) focus +1]
      }
    }
    bind $frame <FocusIn> [list DMegaWdg::DMegaWdg:FocusIn $frame]
    
    #    $wdgname  $frame
    proc $frame { args } {
      variable DMegaWdg
      
      set frame [lindex [info level 0] 0]  
      switch -exact -- [lindex $args 0] {
        bind {
          foreach fw [GetTkWdgFromMegaWdg $frame [lindex $args 1]] {
            bind $fw [lindex $args 2] [list eval [lindex $args 3]]
          }
        }
        cget {
          set opt    [lindex $args 1]
          set subwin [LSearchNP $DMegaWdg($DMegaWdg($frame,wdgname),opts) $opt +1]
          set subopt [LSearchNP $DMegaWdg($DMegaWdg($frame,wdgname),opts) $opt +2]
          if { "$subwin" != "" && "$subopt" != "" } {
            return [$frame$subwin cget $subopt]
          }
          return {}
        }
        configure {
          set opts [lrange $args 1 end]
          if { "$opts" != "" } {
            foreach { opt var } $opts {
              set subwin [LSearchNP $DMegaWdg($DMegaWdg($frame,wdgname),opts) $opt +1]
              set subopt [LSearchNP $DMegaWdg($DMegaWdg($frame,wdgname),opts) $opt +2]
              $frame$subwin configure $subopt $var
            }
          }
        }
        forget {
          foreach subwdg [lrange $args 1 end] {
            set subwin [LSearchNP $DMegaWdg($DMegaWdg($frame,wdgname),names) $subwdg -1]
            pack forget $frame$subwin
          }
        }
        pack {
          foreach subwdg [lrange $args 1 end] {
            set subwin [LSearchNP $DMegaWdg($DMegaWdg($frame,wdgname),names) $subwdg -1]
            if { $subwin == "" } {
              lappend cmd $subwdg
            } else {
              lappend cmd $frame$subwin
            }
          }
          eval pack $cmd
        }
        subwdg {
          set wdgname [lindex $args 1]
          set cmd     [lindex $args 2]
          if { "$wdgname" != "" } {
            set subwin [LSearchNP $DMegaWdg($DMegaWdg($frame,wdgname),names) $wdgname -1]
            eval $frame$subwin $cmd
          }
        }
        names {
          set retnames {}
          foreach { w n } $DMegaWdg($DMegaWdg($frame,wdgname),names) {
            lappend retnames $n
          }
          return $retnames
        }
        window {
          set wdgname [lindex $args 1]
          set win     [LSearchNP $DMegaWdg($DMegaWdg($frame,wdgname),names) $wdgname -1]
          if { "$win" != "" } {
            return $frame$win
          }
        }
        default { 
          error "USAGE: $frame \[bind | cget | configure | forget | pack | subwdg | names | window\]"
        }
      }
    }
    
    rename ::$frame DMegaWdg($frame,frame)
    Scope $frame
    return $frame
  }
  Scope $wdgname
}

#    tk-   
proc GetTkWdgFromMegaWdg { frame usrwdgname } {
  variable DMegaWdg

  set bindwin [LSearchNP $DMegaWdg($DMegaWdg($frame,wdgname),names) $usrwdgname -1]
  regsub -all "(\\n)|(\\\[)|(])" $DMegaWdg($DMegaWdg($frame,wdgname),body) "" body
  set submegawdg [LSearchNP $body $bindwin -1]
  if { [lsearch $DMegaWdg(allmegawdg) $submegawdg] > -1 } {
    foreach { w n } $DMegaWdg($submegawdg,names) {
      lappend ret [GetTkWdgFromMegaWdg $frame$bindwin $n]
    }
  } else {
    set ret $frame$bindwin
  }
  return $ret
}

#    wdgname    
proc Scope { wdgname } {
  namespace export $wdgname
  namespace inscope :: [list namespace import DMegaWdg::$wdgname]
}

#   word   list     np  
proc LSearchNP { list word np } {
  if { [set idx [lsearch -exact $list $word]] > -1 } {
    return [lindex $list [expr $idx $np]]
  }
  return {}
}

}