#   #######################################################

proc WindowCenter { w } {
  update idletasks
  set ms [wm maxsize .]
  set X  [lindex $ms 0]
  set Y  [lindex $ms 1]
  set height [winfo reqheight $w]
  set width  [winfo reqwidth $w]
  wm geometry $w +[expr ($X - $width) / 2]+[expr ($Y - $height) / 2]
  update idletasks
}

proc TkTableInitTag { w } {
  $w tag config AnchorE -anchor e
  $w tag config AnchorW -anchor w
  $w tag config title -fg yellow -bg grey65 -anchor center -wrap 0 -bd 1 -relief raised
  $w tag config rowOne -bg grey88
  $w tag config rowTwo -bg grey85
}
proc TkTableInitBind { w } {
  bind $w <KeyRelease-Return> {
    TkTable:Bind:EnterKpEnter %W
  }
  bind $w <KeyRelease-KP_Enter> {
    TkTable:Bind:EnterKpEnter %W
  }
  bind $w <KeyPress-Down> {
    set rows [%W cget -rows]
    if { [%W index active row] == [expr $rows - 1 + [%W cget -roworigin]] } {
      %W configure -rows [incr rows]
    }
  }
}
proc TkTable:Bind:EnterKpEnter { w } {
  regsub -all "\n|\r" [$w curvalue] "" str
  catch [$w set active $str]
  set endcol [$w index end col]
  set endrow [$w index end row]
  set acol   [$w index active col]
  set arow   [$w index active row]
  if { $acol == $endcol } {
    if { $arow == $endrow } {
      event generate $w <KeyPress-Up>
    } else {
      event generate $w <KeyPress-Down>
    }
    for { set i 0 } { $i < $endcol } { incr i } {
      event generate $w <KeyPress-Left>
    }
  } else {
    event generate $w <KeyPress-Right>
  }
}
proc TkTableRowTagCmd { row } {
    if { [expr $row % 2] == 0 } {
        return rowOne
    }
    return rowTwo
}

#     return 1
proc IsBe { var } {
  upvar $var vr
  if { [info exists vr] && [string trim $vr] != "" } {
    return 1
  }
  return 0
}

#   
proc Status { w msg } {
  if { $w != "" } {
    if ![winfo exists $w.status.l] {
      while { [set w [winfo parent $w]] == "." } {
        if [winfo exists $w.status.l] { break }
      }
    }
  }
  
  if { "$msg" != "" } {
    $w.status.l configure -text $msg
  } else {
    $w.status.l configure -text {}
  }
  update
  after 100
}


# procedure lmath_sum and list_lenhths
# Copyright (c) 1996 Peter De Rijk
#
proc lmath_sum {args} {
  if {[llength $args]!=1} {
    error "wrong # args: should be \"lmath_sum list\""
  }
  set result 0
  foreach e1 [lindex $args 0]  {
    set result [expr {$result+$e1}]
  }
  return $result
}

proc list_lengths {args} {
  if {[llength $args]!=1} {
    error "wrong # args: should be \"list_lengths list\""
  }
  set result ""
  foreach el [lindex $args 0] {
    lappend result [string length $el]
  }
  return $result
}
