proc TableCmd:Any { args } {
  set w .createany_[clock seconds]
  catch [destroy $w]
  toplevel $w
  wm title $w ""
  wm withdraw $w
  pack [frame $w.cline -bd 1 -relief raised] -fill x -side top
  pack [frame $w.status -bd 1 -relief sunken] -side bottom -fill x
  pack [labelframe $w.main -text " Commands for execute " -bd 2] -expand yes -fill both -padx 5 -pady 5
  
  pack [Button $w.cline.execute -image iexecute -command "TableCmd:Any:Execute $w $w.main.txt"] -side left
  Balloon $w.cline.execute "Execute query"
  pack [Button $w.cline.exit    -image iexit    -command "destroy $w"] -side right 
  Balloon $w.cline.exit "Exit window"
  pack [Separator $w.cline.sepend] -side right -fill y -padx 3
  pack [Button $w.cline.help    -image ihelp    -command "Help any"] -side right
  Balloon $w.cline.help "Help"
  LiteXedj $w $w.main "TableCmd:Any:Execute $w $w.main.txt"
  pack [label $w.status.l -fg blue3 -anchor w] -fill x -side left
  
  WindowCenter $w
  wm deiconify $w
  switch -exact -- $args {
    table {
      wm title $w "Table create"
      $w.main.txt insert end "create table \n(\n  id integer not null primary key,\n  \n);\n\n"
      $w.main.txt mark set insert "1.0 lineend"
      for { set row 1 } { $row < 6 } { incr row } {
        LiteXedj:SyntaxExec $w.main.txt $row [$w.main.txt get $row.0 "$row.0 lineend"]
      }
    }
    view {
      wm title $w "Create view"
      $w.main.txt insert end "create view  () as \n  select \n    from \n    where \n;\n\n"
      $w.main.txt mark set insert 1.12
      for { set row 1 } { $row < 6 } { incr row } {
        LiteXedj:SyntaxExec $w.main.txt $row [$w.main.txt get $row.0 "$row.0 lineend"]
      }
    }
    index {
      wm title $w "Create index"
      $w.main.txt insert end "create unique index \n  on  ()\n;\n\n"
      $w.main.txt mark set insert 1.21
      for { set row 1 } { $row < 3 } { incr row } {
        LiteXedj:SyntaxExec $w.main.txt $row [$w.main.txt get $row.0 "$row.0 lineend"]
      }
    }
    trigger {
      wm title $w "Create trigger"
      $w.main.txt insert end "create trigger \n  before insert on \n  for each row\n    begin\n    \n    end\n;\n\n" 
      $w.main.txt mark set insert 1.15
      for { set row 1 } { $row < 8 } { incr row } {
        LiteXedj:SyntaxExec $w.main.txt $row [$w.main.txt get $row.0 "$row.0 lineend"]
      }
    }
    default {
      wm title $w "Create Any Object"
    }
  }
}

proc TableCmd:Any:Execute { main w } {
  global Main
  set lrun [$w get 1.0 end]
  Status $main "Execution ..."
  set err [catch "dbs eval [list $lrun] A { parray A }" error]
  if { $err } {
    tk_dialog $main.dlg error $error error 0 Ok
  } else {
    if [regexp -nocase "create *table" $lrun] {
      OpenDBS $Main(dbname)
    }
  }
  Status $main ""
}

proc TableCmd:Delete { w tbl } {
  if { [Objects:Drop $w Table $tbl] == 1 } {
    foreach i [.main.cv find all] {
      set idname [.main.cv gettags $i]
      if [regexp "$tbl" $idname] {
        .main.cv delete $idname
      }
    }
    SaveCfg
    return 1
  }
}